/* Datei:  echo.c
 * Author: gkemnitz
 * Datum:  05.11.2018
 *
 * Echoprogramm fr die PC-Kommunikation ber USART2
 *
 * PmodUSBUSART an JH oben und Jumper JHX gekreuzt
 */ 

#include <avr/io.h>

int main(void){
  UCSR2C=0b110;                   // bertragungsformat 8N1
  UBRR2=51;                       // 9600 Baud
  UCSR2B=(1<<RXEN2)|(1<<TXEN2);   // Empfnger und Sender
  DDRJ = 0xFF;                    // ein; LEDs als Ausgang  

  uint8_t daten, Ct=0;            // Zhler LED-Ausgabe 

  while(1){
    while (!(UCSR2A & (1<<RXC2)));// warte auf ein Byte
    daten = UDR2;                 // Byte uebernehmen
    while (!(UCSR2A &(1<<UDRE2)));// warte Puffer frei
    UDR2 = daten;                 // Byte bergeben
    PORTJ=Ct;                     // Zhlausgabe auf
    Ct++;                         // LED erhhen
  }
}
